import { getMeDataApi, getRcOptionsApi } from 'mocp/api/mechanicalAbnormalEvents'
import { defineStore } from 'pinia'

const useMechanicalAbnormalEventsStore = defineStore('mechanicalAbnormalEvents', {
    state: () => {
        return {
            searchData: {
                isOpen: 1,
                ac: '',
                acType: '',
                acOwn: '',
                eventType: 0,
                runEvent: null,
                happenStn: '',
                delayNature: '',
                delayProperty: '',
                startTime: null,
                stopTime: null,
                flightNo: '',
                msg: ''
            },
            selectList: {
                assurePhase: [],
                commentConclusion: [],
                delayNature: [],
                delayProperty: [],
                eventType: [],
                flightImpact: [],
                liabilityNature: [],
                majorClass: [],
                occurArea: [],
                runPhase: [],
                stopReason: []
            },
            workbenchId: '',
            details: undefined
        }
    },
    getters: {},
    actions: {
        async getRcOptions() {
            const res = await getRcOptionsApi({})
            if (res.code == 200) {
                this.selectList.assurePhase = res.data.assurePhase || []
                this.selectList.commentConclusion = res.data.commentConclusion || []
                this.selectList.delayNature = res.data.delayNature || []
                this.selectList.delayProperty = res.data.delayProperty || []
                this.selectList.eventType = res.data.eventType || []
                this.selectList.flightImpact = res.data.flightImpact || []
                this.selectList.liabilityNature = res.data.liabilityNature || []
                this.selectList.majorClass = res.data.majorClass || []
                this.selectList.occurArea = res.data.occurArea || []
                this.selectList.runPhase = res.data.runPhase || []
                this.selectList.stopReason = res.data.stopReason || []
            }
        },
        async getMeData() {
            const res = await getMeDataApi({ workbenchId: this.workbenchId }, { loading: true })
            if (res.code == 200) {
                this.details = res.data
            } else {
                uni.$mocpMessage.error(res.message)
            }
        },
        resetForm() {
            this.searchData = {
                isOpen: 1,
                ac: '',
                acType: '',
                acOwn: '',
                eventType: 0,
                runEvent: null,
                happenStn: '',
                delayNature: '',
                delayProperty: '',
                startTime: null,
                stopTime: null,
                flightNo: '',
                msg: ''
            }
        },
        setState(...args) {
            this.$patch({ [args[0]]: args[1] })
        }
    },
    // 配置持久化
    persist: false
})
export default useMechanicalAbnormalEventsStore
